/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GatewayDraftCreateData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GatewayDraftCreateData{}

// GatewayDraftCreateData struct for GatewayDraftCreateData
type GatewayDraftCreateData struct {
	ChannelId string `json:"channel_id"`
	Type Messenger `json:"type"`
	Provider Provider `json:"provider"`
}

// NewGatewayDraftCreateData instantiates a new GatewayDraftCreateData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGatewayDraftCreateData(channelId string, type_ Messenger, provider Provider) *GatewayDraftCreateData {
	this := GatewayDraftCreateData{}
	this.ChannelId = channelId
	this.Type = type_
	this.Provider = provider
	return &this
}

// NewGatewayDraftCreateDataWithDefaults instantiates a new GatewayDraftCreateData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGatewayDraftCreateDataWithDefaults() *GatewayDraftCreateData {
	this := GatewayDraftCreateData{}
	return &this
}

// GetChannelId returns the ChannelId field value
func (o *GatewayDraftCreateData) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *GatewayDraftCreateData) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *GatewayDraftCreateData) SetChannelId(v string) {
	o.ChannelId = v
}

// GetType returns the Type field value
func (o *GatewayDraftCreateData) GetType() Messenger {
	if o == nil {
		var ret Messenger
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *GatewayDraftCreateData) GetTypeOk() (*Messenger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *GatewayDraftCreateData) SetType(v Messenger) {
	o.Type = v
}

// GetProvider returns the Provider field value
func (o *GatewayDraftCreateData) GetProvider() Provider {
	if o == nil {
		var ret Provider
		return ret
	}

	return o.Provider
}

// GetProviderOk returns a tuple with the Provider field value
// and a boolean to check if the value has been set.
func (o *GatewayDraftCreateData) GetProviderOk() (*Provider, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Provider, true
}

// SetProvider sets field value
func (o *GatewayDraftCreateData) SetProvider(v Provider) {
	o.Provider = v
}

func (o GatewayDraftCreateData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GatewayDraftCreateData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["type"] = o.Type
	toSerialize["provider"] = o.Provider
	return toSerialize, nil
}

type NullableGatewayDraftCreateData struct {
	value *GatewayDraftCreateData
	isSet bool
}

func (v NullableGatewayDraftCreateData) Get() *GatewayDraftCreateData {
	return v.value
}

func (v *NullableGatewayDraftCreateData) Set(val *GatewayDraftCreateData) {
	v.value = val
	v.isSet = true
}

func (v NullableGatewayDraftCreateData) IsSet() bool {
	return v.isSet
}

func (v *NullableGatewayDraftCreateData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGatewayDraftCreateData(val *GatewayDraftCreateData) *NullableGatewayDraftCreateData {
	return &NullableGatewayDraftCreateData{value: val, isSet: true}
}

func (v NullableGatewayDraftCreateData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGatewayDraftCreateData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


